#ifndef lint
char copyright[] =
"CBSMAIL - Version "VERSION"\nCopyright (c) 1995 Brian A. Lantz. All rights reserved.\n";
#endif /* not lint */


#include <sys/types.h>
#include <stdio.h>
#include <strings.h>
#include <ctype.h>
#include <sys/file.h>
#include <time.h>
#include <sys/stat.h>
#include <unistd.h>
#include "cbs.h"

#define MAILER		"/usr/lib/sendmail"
#define NULLFILE	((FILE *)0)
#define NULLCHAR	((char *)0)

void read_header (void);

char to[256];
char buf[BUFSIZ];
char cmdbuf[2048];


void
read_header (void)
{
char *p, *temp;
int i;

	while (fgets(buf,BUFSIZ,stdin) != NULL)	{
		/* drop trailing newline */
		while (buf[(i=strlen(buf)-1)] == '\n')
			buf[i] = '\0';

		/* drop trailing blanks */
		p = buf + (strlen(buf) - 1);
		while (p && *p && p >= buf && isspace(*p))
			*p-- = '\0';

		/* deblank beginning of line */
		p = buf;
		while (p && *p && isspace(*p))
			p++;
		if (p != buf)
			strcpy(buf, p);

		if (strlen(buf) == 0)	 /* blank line ends header */
			return;
		
		/* get the From: line so we can file the message */
		if (strncasecmp(buf,"From: ",6) == 0)	{
			p = &buf[6];
			if (*p == '"') {
				p++;
				if ((temp = strchr (p, '"')) != NULLCHAR)
					p = temp+1;
			}
			if ((temp = strchr (p, '<')) != NULLCHAR)      {
				p = temp+1;
				if ((temp = strchr (p, '>')) != NULLCHAR)
					*temp = 0;
			}
			if ((temp = strpbrk (p, " \t")) != NULLCHAR)
				*temp = 0;
			strcpy (to, p);
		}
	}
		
}


int
main(int argc,char **argv)
{
	read_header ();
	
	if (*to)	{
		while (fgets(buf,BUFSIZ,stdin) != NULL)	{
			buf[strlen(buf) - 1] = 0;
			if (!*buf)
				continue;
			if (!strcasecmp(buf, "end"))
				break;
			sprintf (cmdbuf, "(echo Subject: \"Callserver Request '%s'\"; %s %s; echo; echo '***' Processed by CBSMail Version "VERSION" '***') | %s -oi -fcallserver %s",
				buf, _PATH_CALLBOOK, buf, MAILER, to);
			system (cmdbuf);
		}
	}

	exit(0);
}
